Sustainsys.Saml2.StubIdp/Controllers/CertificateController.cs
using System.IO;
using System.Net.Mime;
using System.Web.Mvc;

namespace Sustainsys.Saml2.StubIdp.Controllers
{
    public class CertificateController : Controller
    {
        public ActionResult Index()
        {
            var path = Request.Url.Host == "stubidp.kentor.se"
                ? HttpContext.Server.MapPath("~\\App_Data\\Kentor.AuthServices.StubIdp.cer")
                : HttpContext.Server.MapPath("~\\App_Data\\stubidp.sustainsys.com.cer");

            var disposition = new ContentDisposition { Inline = false, FileName = Path.GetFileName(path) };
            Response.AppendHeader("Content-Disposition", disposition.ToString());
            return File(path, MediaTypeNames.Text.Plain);
        }
    }
}

Sustainsys.Saml2.StubIdp/Controllers/DiscoveryServiceController.cs
using Sustainsys.Saml2.StubIdp.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Sustainsys.Saml2.StubIdp.Controllers
{
    public class DiscoveryServiceController : Controller
    {
        public ActionResult Index(DiscoveryServiceModel model)
        {
            if(model.isPassive || Request.HttpMethod == "POST")
            {
                string delimiter = model.@return.Contains("?") ? "&" : "?";

                return Redirect(string.Format(
                    "{0}{1}{2}={3}",
                    model.@return,
                    delimiter,
                    model.returnIDParam,
                    model.SelectedIdp));
            }

            return View(model);
        }
    }
}

Sustainsys.Saml2.StubIdp/Controllers/MetadataController.cs
using Sustainsys.Saml2.Metadata.Extensions;
using Sustainsys.Saml2.StubIdp.Models;
using System.Security.Cryptography.Xml;
using System.Web.Mvc;

namespace Sustainsys.Saml2.StubIdp.Controllers
{
    public class MetadataController : Controller
    {
        // GET: Metadata
        public ActionResult Index()
        {
            return Content(
                CreateMetadataString(),
                "application/samlmetadata+xml");
        }

        private static string CreateMetadataString()
        {
            return MetadataModel.CreateIdpMetadata()
                            .ToXmlString(CertificateHelper.SigningCertificate,
                            SignedXml.XmlDsigRSASHA256Url);
        }

        public ActionResult BrowserFriendly()
        {
            return Content(
                CreateMetadataString(),
                "text/xml");
        }
    }
}

Sustainsys.Saml2.StubIdp/Views/Shared/_About.cshtml
<div class="col-lg-4 card">
    <h2>About</h2>
    <div class="contents">
        <p>
            The Stub Idp is part of the <a href="https://github.com/Sustainsys/Saml2">
                Sustainsys.Saml2
            </a> open source package for ASP.NET.
        </p>
        <p>
            The SAML messages sent by the Stub Idp will be signed with
            @Html.ActionLink("this certificate", "Index", "Certificate").
            To validate the responses you need to download it and configure your
            service provider to trust it.
        </p>
        <div class="panel panel-warning">
            <div class="panel-heading">
                Warning
            </div>
            <div class="panel-body">
                Never trust the stub idp certificate in a production environment as it will
                allow anyone to sign in to your application as whatever user they choose.
            </div>
        </div>
        @Html.Partial("_MetadataLink")
        <p>
            The stub idp also features
            @Html.ActionLink("single logout support", "Index", "Logout").
        </p>
    </div>
</div>

Sustainsys.Saml2.StubIdp/Views/Shared/_Layout.cshtml
<!DOCTYPE html>

<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <title>Sustainsys.Saml2 Stub Idp</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
    <link href="https://fonts.googleapis.com/css?family=Titillium+Web:200,400,700" rel="stylesheet">
    @System.Web.Optimization.Styles.Render("~/Content/css-bundle")
    @System.Web.Optimization.Scripts.Render("~/Scripts/js")
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.3/umd/popper.min.js" integrity="sha384-vFJXuSJphROIrBnz7yo7oB41mKfc8JzQZiCq4NCceLEaO4IHwicKwpJf9c9IpFgh" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
    <meta name="description" content="A stub idp for testing" />
</head>
<body>
    <div class="nav navbar navbar-sustainsys navbar-fixed-top">
        <div class="navbar-header">
            <button type="button" class="navbar-toggle pull-left" data-toggle="collapse" data-target=".navbar-collapse">
                <span class="sr-only">Toggle navigation</span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
                <span class="icon-bar"></span>
            </button>
            <a href="https://sustainsys.com">
                <div class="navbar-right pull-right"></div>
            </a>
        </div>
        <div class="navbar-collapse collapse">
            <ul class="nav navbar-nav">
                <li><a href="@Request.ApplicationPath">Home</a></li>
                <li class="dropdown">
                    <a class="dropdown-toggle" href="#" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Metadata<span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu">
                        <li>@Html.ActionLink("Single Idp", "BrowserFriendly", "Metadata")</li>
                        <li>@Html.ActionLink("Federation", "BrowserFriendly", "Federation")</li>
                    </ul>
                </li>
                <li class="dropdown">
                    <a class="dropdown-toggle" href="#" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Tenant<span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu">
                        @if (ViewContext.RouteData.Values["idpId"] != null)
                    {
                        <li>@Html.ActionLink("Home", "Index", "Home", null, new { @class = "dropdown-item" })</li>
                        <li>@Html.ActionLink("Manage", "Index", "Manage", null, new { @class = "dropdown-item" })</li>
                }
                        <li>@Html.ActionLink("Create New", "Index", "Manage", new { idpId = Guid.NewGuid() }, null)</li>
                    </ul>
                </li>
                <li class="dropdown">
                    <a class="dropdown-toggle" href="#" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        Services<span class="caret"></span>
                    </a>
                    <ul class="dropdown-menu">
                        <li>@Html.ActionLink("Single Sign On", "Index", "Home")</li>
                        <li>@Html.ActionLink("Single Logout", "Index", "Logout")</li>
                        <li>@Html.ActionLink("Discovery Service", "Index", "DiscoveryService")</li>
                    </ul>
                </li>
            </ul>
        </div>
        @if(ViewBag.Title != null)
        {
            <div class="page-heading">
                @ViewBag.Title
            </div>
        }
    </div>
    @RenderBody()
    <script>
        (function (i, s, o, g, r, a, m) {
            i['GoogleAnalyticsObject'] = r; i[r] = i[r] || function () {
                (i[r].q = i[r].q || []).push(arguments)
            }, i[r].l = 1 * new Date(); a = s.createElement(o),
            m = s.getElementsByTagName(o)[0]; a.async = 1; a.src = g; m.parentNode.insertBefore(a, m)
        })(window, document, 'script', '//www.google-analytics.com/analytics.js', 'ga');

        ga('create', 'UA-46788957-1', 'auto');
        ga('send', 'pageview');

    </script>
</body>
</html>

Sustainsys.Saml2.StubIdp/Views/Shared/_MetadataLink.cshtml
<p>
    Metadata for the Stub Idp is available at @Html.ActionLink(UrlResolver.MetadataUrl.PathAndQuery, "Index", "Metadata") or in a
    @Html.ActionLink("browser friendly version", "BrowserFriendly", "Metadata") version (with a content type
    that makes the browser display the entire XML). There is also
    @Html.ActionLink("federation metadata", "Index", "Federation"), with this idp as the only federation member
    available (@Html.ActionLink("browser friendly version", "BrowserFriendly", "Federation")).
</p>

<p>
    The Stub idp contains a @Html.ActionLink("stub idp discovery service", "Index", "DiscoveryService") that
    can be used when testing federations.
</p>